//===========================================================================
// Dreidimensionale Krper
//===========================================================================

//===========================================================================
// includes
//===========================================================================

// GL und GLUT Bibliotheken einbinden (je nach Betriebssystem)

#ifdef WIN32
    #include <windows.h>
    #include <GL/gl.h>
    #include <GL/glut.h>
#else
    #include <GLUT/glut.h>
#endif

#include "cube.h"

#include <stdlib.h> // exit()


//===========================================================================
// Globale variablen
//===========================================================================

int   glutWindow = 0;
CCube cube;


//===========================================================================
// OpenGL Zeichenfunktion
//===========================================================================

void transform(unsigned int width, unsigned int height)
{
    // OpenGL Transformationen initialisieren...
    // Ausgabefenstergre setzen
    glViewport(0, 0, (GLint)width, (GLint)height);

    // Transformationen fr 3D-Koordinaten bearbeiten
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    // Kameraposition setzen
    gluLookAt(0.0, 0.0, 4.0,  // von wo
              0.0, 0.0, 0.0,  // nach wo
              0.0, 1.0, 0.0); // wo ist oben?

    // Perspektivische Projektion bearbeiten
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    // Verhltnis Breite zu Hhe (aspect) berechnen
    GLdouble aspect = (GLdouble)width / (GLdouble)height;
    
    // Kameraperspektive setzen
    gluPerspective(53,           // ffnungswinkel vertikal (field of view)
                   aspect,       // aspect ratio setzen
                   0.001, 10.0); // nahe und ferne Begrenzungsebene setzen
}


//===========================================================================
// GLUT callback funktionen
//===========================================================================

void display(void)
{
    // Ausgabefenster in schwarz lschen
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    // Transformationen vor dem Zeichnen setzen
    transform(glutGet(GLUT_WINDOW_WIDTH), glutGet(GLUT_WINDOW_HEIGHT));

    // Wrfelrotation aktualisieren (angenommen: 60Hz)
    cube.update(1.0f / 60.0f);

    // Zeichnen
    glColor3f(0.6f, 0.8f, 0.4f);
    cube.render();

    // Hintergrundpuffer anzeigen
    glutSwapBuffers();
}


void idle(void)
{
    // nochmaliges Zeichnen einleiten
    if (glutWindow != 0) glutPostRedisplay();
}


void keyboard(unsigned char key, int x, int y)
{
    // Fenster schlieen
    glutDestroyWindow(glutWindow);
    glutWindow = 0;

    // Programm beenden (etwas unsauber)
    exit(0);
}


//===========================================================================
// Hauptroutine
//===========================================================================

int main(int argc, char* argv[])
{
    // GLUT initialisieren
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);

    // Fenster ffnen
    glutWindow = glutCreateWindow("Wuerfel");

    // GLUT Funktionen fr Zeichnen, Leerlauf, Tastatur und Maus setzen
    glutDisplayFunc(display);
    glutIdleFunc(idle);
    glutKeyboardFunc(keyboard);

    // Vollbildmodus ohne Mauszeiger
    glutFullScreen();
    glutSetCursor(GLUT_CURSOR_NONE);

    // Tiefenpuffer-Test einschalten
    glEnable(GL_DEPTH_TEST);

    // Hauptschleife des Programms aufrufen
    glutMainLoop();

    // Bis hierhin kommt das Programm nicht
    return 0;
}
